import Foundation
import AsyncAlgorithms
import PlaygroundSupport

PlaygroundPage.current.needsIndefiniteExecution = true

struct MyError: Error {}

let (stream, continuation) = AsyncThrowingStream.makeStream(of: Int.self)

// consume the stream
Task {
    do {
        for try await value in stream.debounce(for: .seconds(0.1)) {
            print(value)
        }
        print("Stream ended normally")
    }
    catch {
        print("Stream ended by throwing")
    }
}

// produce the values (and exception)
Task {
    for i in 1...10 {
        if i == 5 {
            continuation.finish(throwing: MyError())
        }
        else {
            continuation.yield(i)
        }
        try await Task.sleep(for: .seconds(0.3))
    }
    continuation.finish()
}

